﻿<%@ Application Language="C#" %>
<%@ Import Namespace="System.Web.Mvc" %>
<%@ Import Namespace="System.Web.Routing" %>
<script RunAt="server">

    public static void RegisterRoutes(RouteCollection routes)
    {
        //http://www.1csoftware.com/application/en_US/webclient.css?sysver=8.2.15.310
        routes.MapRoute(
            "ProxyLanguage",                                              // Route name
            "{application}/{lang}/{*pathInfo}",                      // URL with parameters
            new { lang = System.Globalization.CultureInfo.CurrentUICulture.Name, controller = "Proxy", action = "Transfer", pathInfo = UrlParameter.Optional },
            new { lang = @"\w{2}_\w{2}|\w{2}" }
        );

        routes.MapRoute(
            "Proxy",                                              // Route name
            "{application}/{*pathInfo}",                      // URL with parameters
            new { controller = "Proxy", action = "Transfer", pathInfo = UrlParameter.Optional }
        );
        
        routes.MapRoute(
            "Default", // Route name
            "{controller}/{action}/{id}", // URL with parameters
            new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
        );
    }

    void Application_Start(object sender, EventArgs e)
    {
        //Workaround error Invalid JSON primitive: undefined. when Post data contains {"root":{"cacheID":undefined, ...
        ValueProviderFactories.Factories.Remove(
                    ValueProviderFactories.Factories.OfType<JsonValueProviderFactory>().First());
        
        
        AreaRegistration.RegisterAllAreas();

        RegisterRoutes(RouteTable.Routes);
    }

    void Application_End(object sender, EventArgs e)
    {
        //  Code that runs on application shutdown

    }

    void Application_Error(object sender, EventArgs e)
    {
        if (Request.IsLocal)
            return;
        
    }

    void Session_Start(object sender, EventArgs e)
    {
        // Code that runs when a new session is started

    }

    void Session_End(object sender, EventArgs e)
    {
        // Code that runs when a session ends. 
        // Note: The Session_End event is raised only when the sessionstate mode
        // is set to InProc in the Web.config file. If session mode is set to StateServer 
        // or SQLServer, the event is not raised.

    }
       
</script>
